<template>
  <div v-if="showPage == true">
    <div class="p-lg-5 mb-5 panel-actu--lg">
      <CoolLightBox :items="itemsLightbox" :index="index" :effect="'fade'" @close="index = null"></CoolLightBox>
      <b-row no-gutters>
        <b-col md="6">
          <div class="pb-4 p-sm-3">
            <!-- Image principale -->
            <div class="box-img">
              <div class="box-img__img" @click="index = 0" :style="{ backgroundImage: 'url(' + urlFTP + 'tn/tn1-' + typeChamps['image'][0].value + ')' }" v-if="typeChamps['image'][0].value != ''"></div>
            </div>
            <!-- Images dans bloc images-->
            <b-row no-gutters class="mt-3 mr-n3">
              <b-col cols="4" lg="3" class="pr-3 pb-3" v-for="(idxImg, indice) in typeChamps.image.length" :key="indice">
                <div class="box-img" v-if="typeChamps['image'][indice].value != ''">
                  <div class="box-img__img" @click="index = indice" :style="{ backgroundImage: 'url(' + urlFTP + 'tn/tn1-' + typeChamps['image'][idxImg - 1].value + ')' }"></div>
                </div>
              </b-col>
            </b-row>
          </div>
        </b-col>
        <b-col md="6">
          <div class="p-sm-3 p-lg-5">
            <!-- Titre de l'actu-->
            <h3 class="card-title" v-if="typeChamps['titre'][0].value">{{ typeChamps["titre"][0].value }}</h3>
            <!-- Date -->
            <p>
              <small class="text-muted">Publié le {{ moduleContent.created_at | simplyDate }} </small>
            </p>
            <!-- Descriptif -->
            <div v-html="typeChamps['description'][0].value" v-if="typeChamps['description'][0].value != ''"></div>

            <hr class="my-4" />
            <!-- Social -->
            <share></share>
          </div>
        </b-col>
      </b-row>
    </div>
  </div>
</template>
<script>
import Share from "./share.vue";
import moduleConfig from "@/config-data/config-products.json"; // a passer en parametres si possible
const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_DATAS_DETAIL = URL_API + "api/popups/show/";
const URL_DATAS_ACTIV = URL_API + "api/popups/list/activ/";

export default {
  components: {
    share: Share
    // "news-horizontal": NewsHorizontal
  },
  beforeMount: function() {
    this.idFiche = this.$route.params.id;
    this.moduleName = this.$route.params.moduleName;
    console.log("this.moduleName", this.moduleName);
    if (this.moduleName == "" || this.moduleName == undefined) {
      this.$router.push({ name: "accueil" });
    }
    this.fetchDatas();
  },
  data() {
    return {
      // test
      tabIdx: [],
      initialList: [],
      urlFTP: process.env.VUE_APP_URL_UPLOAD_FOLDER + process.env.VUE_APP_SITE_ALIAS + "/",
      showModalAdd: false,

      showAddCardBtn: false,
      moduleConfig,

      // variables structure data
      champs: null,
      typeChamps: [],
      variantsChoices: [],
      variantsList: [],
      filteredVariantsList: [],
      variantsOriginal: [],
      filteredVariantsData: [],
      champsPrix: [],
      moduleContent: [],
      filteredModule: {},

      showPage: false,
      slide: 0,
      sliding: null,
      idFiche: null,
      itemsLightbox: [],
      index: null,
      imageIndex: 0,

      show: true,

      moduleName: "",
      // moduleName: "actualite1",
      listProducts: []
    };
  },
  methods: {
    fetchDatas() {
      this.$axios
        .get(URL_DATAS_DETAIL + this.idFiche)
        .then(response => {
          this.moduleContent = response.data.data;
          this.structureData();
        })
        .catch(error => {
          console.log("error", error);
        });
    },
    structureData() {
      // récupération de la config du module et des valeurs en bdd
      // pour creer un tableau des valeurs de la fiche associé à la config du module
      // sur lequel on peut itérer

      this.filteredModule = this.moduleConfig.filter(item => {
        return item.module === this.moduleName;
      });

      this.champs = JSON.parse(this.moduleContent.data);
      this.champsPrix = JSON.parse(this.moduleContent.dataprix);
      this.filteredModule[0].config.forEach(el => {
        // construction de la ligne
        let rawData = [];
        rawData.type = el.champs;
        rawData.value = this.champs[el.champs];
        rawData.libelle = el.libelle;
        // push de la ligne dans le tableau
        if (el.type == "liste") {
          rawData.items = el.items;
        }
        if (el.type in this.typeChamps) {
          this.typeChamps[el.type].push(rawData);
        } else {
          this.typeChamps[el.type] = [];
          this.typeChamps[el.type].push(rawData);
        }
      });

      // récupération config images
      this.typeChamps["image"] = [];
      this.filteredModule[0].medias.libellesImages.forEach((el, index) => {
        let rawData = [];
        rawData.type = "image" + parseInt(index + 1);
        rawData.value = this.champs["image" + parseInt(index + 1)];
        rawData.libelle = el;
        this.typeChamps["image"].push(rawData);
      });

      // intégration du tableau d'image dans le tableau pour le lightbox
      this.typeChamps["image"].forEach(img => {
        if (img.value.length > 0 && img.value !== "") {
          let rawImg = {
            title: "",
            description: "",
            src: this.urlFTP + "tn/tn1-" + img.value,
            thumb: this.urlFTP + "tn/tn1-" + img.value
          };
          this.itemsLightbox.push(rawImg);
        }
      });

      // suppression des lignes ne contenant pas d'images
      this.typeChamps["image"] = this.typeChamps["image"].filter(elem => {
        return elem.value !== "" && elem.value !== undefined && elem.value.length > 0;
      });

      // récupération config pdf

      this.typeChamps["pdf"] = [];
      this.filteredModule[0].medias.libellesPdf.forEach((el, index) => {
        let rawData = [];
        rawData.type = "pdf" + parseInt(index + 1);
        rawData.value = this.champs["pdf" + parseInt(index + 1)];
        rawData.libelle = el;
        this.typeChamps["pdf"].push(rawData);
      });

      // suppression des lignes ne contenant pas de pdf
      this.typeChamps["pdf"] = this.typeChamps["pdf"].filter(elem => {
        return elem.value !== "" && elem.value !== undefined && elem.value.length > 0;
      });

      // récupération config prix
      if (this.champsPrix.typePrix == "simple") {
        this.typeChamps["prix"] = [];
        if (this.filteredModule[0].prix.length > 0) {
          this.filteredModule[0].prix.forEach((el, index) => {
            let rawData = [];
            rawData.type = "prix" + parseInt(index + 1);
            rawData.value = this.champsPrix.simplePrice[index]["prix" + parseInt(index + 1)];
            rawData.libelle = el.libelle;
            this.typeChamps["prix"].push(rawData);
          });
        }
        this.showAddCardBtn = true;
      }

      // this.checkPrevNext();

      // on récupère la liste des produits puis on l'enregistre pour passer au productnav
      if (this.$route.params.listProducts && this.$route.params.listProducts.length > 0) {
        this.listProducts = this.$route.params.listProducts;
      }

      console.log("typeChamps", this.typeChamps);

      this.showPage = true;
    },
    // Suppression doublons tableau / merci stackoverflow pour la fonction
    uniq(a) {
      return a.sort().filter(function(item, pos, ary) {
        return !pos || item !== ary[pos - 1];
      });
    }
  }
};
</script>
